
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.SIMON96_pkg.all;

entity SIMON96_Round is
generic( 
        BS  : integer := SIMON_BLOCK_SIZE; 
        KS  : integer := SIMON_KEY_SIZE; 
        WS  : integer := SIMON_WORD_SIZE );
    port(
        din 		: in  std_logic_vector(BS  -1 downto 0);
        rkey        : in  std_logic_vector(KS  -1 downto 0);
        dout_fdb 	: out std_logic_vector(BS  -1 downto 0)
    );
end SIMON96_Round;


architecture behavior of SIMON96_Round is
begin
    -- R = y = din(WS-1 downto  0) 
    -- L = x = din(BS-1 downto WS)
    
    --xlr1 <= din(BS-2 downto  WS) & din(BS-1); 
    --xlr2 <= (din(BS-3 downto WS) & din(BS-1 downto BS-2));
    --xlr8 <= (din(BS-9 downto WS) & din(BS-1 downto BS-8));

    dout_fdb(BS-1 downto WS) <= din(WS-1 downto  0) xor 
                                ((din(BS-2 downto  WS) & din(BS-1)) and (din(BS-9 downto WS) & din(BS-1 downto BS-8))) xor 
                                (din(BS-3 downto WS) & din(BS-1 downto BS-2)) xor 
                                rkey(WS-1 downto 0); 
    dout_fdb(WS-1 downto  0) <= din(BS-1 downto  WS); 

end behavior;